<template>
    <input
        name="name"
        id="name"
        type="text"
        placeholder="Game name"
        v-model="input"
        autocomplete="off"
        @keyup="validateInput"
        @change="maxInputReached"
        required
        :maxlength="maxInput"
        class="appearance-none block w-full bg-gray-200 text-gray-700 border border-gray-300 rounded py-3 px-4 mb-3 leading-tight focus:outline-none focus:bg-white"
    >
    <div class="accent-red-500" v-if="error">
        {{ error }}
    </div>
</template>

<script>
import { ref } from "vue"
export default {
    setup: function () {
        let input = ref("");
        let error = ref("");
        let maxInput = 50;

        const validateInput = () => {
            error.value = input.value === "" ? "The input field is required" : "";
        };

        const maxInputReached = () => {
            error.value = input.value.length === maxInput ? "Max length has been reached!" : "";
        }

        return {
            input,
            error,
            maxInput,
            validateInput,
            maxInputReached
        };
    }
}
</script>

<style scoped>

</style>
